
#include <iostream>
#include "ContextFreeGrammar.h"
#include "LL1ParserGenerator.h"
using namespace std;
using namespace ContextFreeGrammars;


void printstack(const std::vector<const Symbol*>& stack)
{
    cout << "    ";
    for(std::vector<const Symbol*>::const_iterator i = stack.begin(); i != stack.end(); i++)
        cout << (*i)->Name << " ";
    cout << endl;
}


int main(int argc, char** argv)
{
    ContextFreeGrammar cfg;
    cfg.LoadFromStream(cin);


    /*
    cout << "Grammar:" << endl
         << "========" << endl;
    cfg.WriteToStream(cout);
    */

    LL1ParserGenerator parsergen(cfg);
    if(parsergen.IsLL1Grammar())
    {
        parsergen.GenerateRecursiveDescentParser(cout);
    }
    else
    {
        cerr << "This is not an LL(1) Grammar. Cannot proceed." << endl;
    }


    /*
    cout << endl << "Chomsky-Normalform:" << endl
                 << "===================" << endl;
    cfg = cfg.ChomskyNormalForm();
    cfg.WriteToStream(cout);
    */


    /*
    cout << endl << "Produced Words:" << endl
                 << "===============" << endl;
    for(int k = 0; ; k++)
    {
        cout << "depth " << k << endl;
        cfg.Produce(k, printstack);
    }
    */

    return 0;
}